#include "ProviderSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::ltm
{

    wm::ProviderSegment ProviderSegment::convert() const
    {
        wm::ProviderSegment m;
        for (const auto& [_, s] : _container)
        {
            m.addEntity(s.convert());
        }
        return m;
    }

    void ProviderSegment::append(const wm::ProviderSegment& m)
    {
        for (const auto& [k, s] : m.container())
        {
            if (const auto& it = _container.find(k); it != _container.end())
            {
                it->second.append(s);
            }
            else
            {
                auto wms = _container.emplace(std::make_pair(k, id().withEntityName(k)));
                wms.first->second.append(s);
            }
        }
    }
}
