#pragma once

#include "../base/ProviderSegmentBase.h"

#include "Entity.h"
#include "detail/CopyWithoutData.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        public base::ProviderSegmentBase<Entity, ProviderSegment>,
        public detail::CopyWithoutData<ProviderSegment>

    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:

        using Base::ProviderSegmentBase;

        ProviderSegment(const ProviderSegment& other) = default;
        ProviderSegment(ProviderSegment&& other) = default;
        ProviderSegment& operator=(const ProviderSegment& other) = default;
        ProviderSegment& operator=(ProviderSegment&& other) = default;

        virtual ~ProviderSegment() override = default;


    protected:

        virtual void _copySelfWithoutData(ProviderSegment& other) const override;

    };

}
