#pragma once


namespace armarx::armem::wm::detail
{

    /**
     * @class Allows copying `*this` without data in the leaf
     * data structures.
     */
    template <class DerivedT>
    class CopyWithoutData
    {
    public:

        /// Get a copy of `this` without data.
        virtual DerivedT copyWithoutData() const
        {
            DerivedT t;
            _copySelfWithoutData(t);
            return t;
        }


    protected:

        virtual void _copySelfWithoutData(DerivedT& other) const = 0;

    };
}
