#include "LTMControlWidget.h"

#include <QPushButton>
#include <QLineEdit>
#include <QTimer>
#include <QHBoxLayout>

#include <cmath>


namespace armarx::armem::gui
{

    LTMControlWidget::LTMControlWidget()
    {
        setSizePolicy(QSizePolicy::Policy::Minimum, QSizePolicy::Policy::Fixed);

        QLayout* layout = new QHBoxLayout();
        this->setLayout(layout);

        const int margin = 0;
        layout->setContentsMargins(margin, margin, margin, margin);

        _lineEdit = new QLineEdit("/tmp/MemoryExport", this);
        _exportHereButton = new QPushButton("Export here", this);

        _storeButton = new QPushButton("Store in LTM", this);

        layout->addWidget(_lineEdit);
        layout->addWidget(_storeButton);
        layout->addWidget(_exportHereButton);

        // Private connections.

        // Public connections.
        connect(_storeButton, &QPushButton::pressed, this, &This::store);
        connect(_exportHereButton, &QPushButton::pressed, this, &This::exportHere);
    }

    QLineEdit* LTMControlWidget::pathInputBox()
    {
        return _lineEdit;
    }

    QString LTMControlWidget::getEnteredPath()
    {
        return _lineEdit->text();
    }

    QPushButton* LTMControlWidget::storeButton()
    {
        return _storeButton;
    }

    QPushButton* LTMControlWidget::exportHereButton()
    {
        return _exportHereButton;
    }
}

