#include "sanitize_typename.h"

#include <sstream>

#include <SimoxUtility/algorithm/string.h>

#include <RobotAPI/libraries/armem/aron/MemoryID.aron.generated.h>


static const std::string MemoryIDTypeName = armarx::armem::arondto::MemoryID::toInitialAronType()->getName();

std::string armarx::armem::gui::instance::sanitizeTypeName(const std::string& typeName)
{
    if (typeName == MemoryIDTypeName)
    {
        return "MemoryID";
    }

    namespace s = simox::alg;
    std::string n = typeName;
    n = s::replace_all(n, "Aron", "");
    n = s::replace_all(n, "Type", "");
    n = s::replace_all(n, "type::", "");
    if (s::starts_with(n, "Object<") && s::ends_with(n, ">"))
    {
        std::string begin = "Object<";
        std::string end = ">";
        n = n.substr(begin.size(), n.size() - begin.size() - end.size());
    }

    if (true)
    {
        const std::string del = "::";
        size_t find = n.rfind(del);
        if (find != n.npos)
        {
            find += del.size();  // include del
            std::stringstream ss;
            ss << n.substr(find) << "    (" << n.substr(0, find - del.size()) << ")";
            n = ss.str();
        }
    }

    return n;

}
